using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using AxShockwaveFlashObjects;

namespace FlashForm
{
    public partial class Form1 : Form
    {
        private AxShockwaveFlash axShockwaveFlash;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            axShockwaveFlash = new AxShockwaveFlash();
            axShockwaveFlash.Location = new System.Drawing.Point(0, 30);
            this.Controls.Add(axShockwaveFlash);

            axShockwaveFlash.Movie = Path.GetDirectoryName(Application.ExecutablePath) + "\\cannon_basic.swf";
            axShockwaveFlash.Size = new System.Drawing.Size(this.Width, this.Height);
            axShockwaveFlash.FlashCall += new _IShockwaveFlashEvents_FlashCallEventHandler(flashCall);
            axShockwaveFlash.Play();
        }

        //accept flash call
        private void flashCall(object sender, _IShockwaveFlashEvents_FlashCallEvent e)
        {
            XmlDocument request = new XmlDocument();
            request.LoadXml(e.request);

            switch (request.SelectSingleNode("/invoke").Attributes["name"].Value)
            {
                case "change_angle":
                    input_angel.Text = request.GetElementsByTagName("arguments")[0].FirstChild.InnerText;
                    break;
                case "change_speed":
                    input_speed.Text = request.GetElementsByTagName("arguments")[0].FirstChild.InnerText;
                    break;
                case "change_weight":
                    input_G.Text = request.GetElementsByTagName("arguments")[0].FirstChild.InnerText;
                    break;
            }
        }

        // call flash
        private void input_angel_TextChanged(object sender, EventArgs e)
        {
            axShockwaveFlash.CallFunction("<invoke name=\"setAngle\" returntype=\"xml\"><arguments><string>" + input_angel.Text + "</string></arguments></invoke>");
        }

        private void input_speed_TextChanged(object sender, EventArgs e)
        {
            axShockwaveFlash.CallFunction("<invoke name=\"setSpeed\" returntype=\"xml\"><arguments><string>" + input_speed.Text + "</string></arguments></invoke>");
        }

        private void input_G_TextChanged(object sender, EventArgs e)
        {
            axShockwaveFlash.CallFunction("<invoke name=\"setWeight\" returntype=\"xml\"><arguments><string>" + input_G.Text + "</string></arguments></invoke>");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            axShockwaveFlash.CallFunction("<invoke name=\"fireCannon\" returntype=\"xml\" />");
        }
    }
}